﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="MultiRowDisConn.aspx.cs" Inherits="MultiRowDisConn" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>多筆編輯 + 離線編輯 + 多人並行存取衝突偵測 + 批次寫入資料庫 + 保留使用者在 GridView 的輸入值</title>
    <script type="text/javascript">
        // 控制「全部刪除」CheckBox 的勾選與否
        function Check(parentChk,ChildId)
          {
              var oElements = document.getElementsByTagName("INPUT");
              var bIsChecked = parentChk.checked;
          
              for(i=0; i<oElements.length;i++)
              {
                  if( IsCheckBox(oElements[i]) && 
                     IsMatch(oElements[i].id, ChildId))
                 {
                     oElements[i].checked = bIsChecked;
                 }        
             }
         }

         function IsMatch(id, ChildId) {
             var sPattern = '^GridView.*' + ChildId + '$';
             var oRegExp = new RegExp(sPattern);
             if (oRegExp.exec(id))
                 return true;
             else
                 return false;
         }

         function IsCheckBox(chk) {
             if (chk.type == 'checkbox') return true;
             else return false;
         }
     </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:GridView ID="GridView1" runat="server" Font-Size="Small" DataKeyNames="id" ShowFooter="True" AutoGenerateColumns="False" FooterStyle-BackColor="Gold">
            <Columns>
                <asp:TemplateField HeaderText="選取">
                    <headertemplate>
                        <input type="checkbox" id="chkLogAll" name="chkLogAll" onclick="Check(this,'cbSelect')" />刪除
                    </headertemplate>
                    <ItemTemplate>
                        <asp:CheckBox ID="cbSelect" runat="server" ToolTip="被勾選的資料，在按下「存檔」按鈕後，會從資料庫裡刪除" />
                        <asp:HiddenField ID="hfPrimaryKey" runat="server" Value='<%# Eval("id") %>' />
                    </ItemTemplate>
                    <ItemStyle BackColor="Pink" HorizontalAlign="Center" />
                </asp:TemplateField>
            
                <asp:BoundField DataField="id" HeaderText="id" ReadOnly="True" SortExpression="id" >
                    <ItemStyle HorizontalAlign="Center" Width="50px" />
                </asp:BoundField>
                    
                <asp:TemplateField HeaderText="float1">
                  <ItemTemplate>
                      <asp:TextBox ID="tb_float1" runat="server" Text='<%#Eval("float1") %>' Width="50px"></asp:TextBox>                      
                  </ItemTemplate>
                  <FooterTemplate>
                      <asp:TextBox ID="tb_footer_float1" runat="server" Width="50px"></asp:TextBox>                      
                  </FooterTemplate>
                </asp:TemplateField>
                
                <asp:TemplateField HeaderText="date1">
                  <ItemTemplate>
                      <asp:TextBox ID="tb_date1" runat="server" Text='<%#Eval("date1", "{0:yyyy/MM/dd}") %>' Width="70px"></asp:TextBox>
                  </ItemTemplate>
                  <FooterTemplate>
                      <asp:TextBox ID="tb_footer_date1" runat="server" Width="70px"></asp:TextBox>                      
                  </FooterTemplate>
                    <ItemStyle Width="75px" />
                </asp:TemplateField>
                
                <asp:TemplateField HeaderText="varchar1">
                  <ItemTemplate>
                      <asp:TextBox ID="tb_varchar1" runat="server" Text='<%#Eval("varchar1") %>' ></asp:TextBox>
                  </ItemTemplate>
                  <FooterTemplate>
                      <asp:TextBox ID="tb_footer_varchar1" runat="server"></asp:TextBox>
                  </FooterTemplate>
                </asp:TemplateField>
                
                <asp:TemplateField HeaderText="varchar2">
                  <ItemTemplate>
                      <asp:TextBox ID="tb_varchar2" runat="server" Text='<%#Eval("varchar2") %>'></asp:TextBox>
                  </ItemTemplate>
                  <FooterTemplate>
                      <asp:TextBox ID="tb_footer_varchar2" runat="server"></asp:TextBox>
                  </FooterTemplate>
                    <ItemStyle HorizontalAlign="Center" />
                </asp:TemplateField>
                
                <asp:TemplateField HeaderText="MODIFY_DT">
                  <ItemTemplate>
                      <asp:Label ID="lbl_MODIFY_DT" runat="server" Text='<%#Eval("MODIFY_DT") %>'></asp:Label>
                      <asp:HiddenField ID="hfMODIFY_DT" runat="server" Value='<%#Eval("MODIFY_DT") %>' />                      
                  </ItemTemplate>                  
                  <FooterTemplate>
                      <asp:Button ID="btnAdd" runat="server" Text="新增" OnClick="btnAdd_Click" CausesValidation="true"  
                        ToolTip="離線新增一筆資料 (不會真正寫入資料庫)" />
                      <asp:Button ID="btnCancer" runat="server" Text="取消" OnClick="btnCancel_Click" ToolTip="清除您在此「新增列」的輸入值" />
                  </FooterTemplate>
                    <FooterStyle HorizontalAlign="Center" />
                    <ItemStyle HorizontalAlign="Center" />
                </asp:TemplateField>
                
                
            </Columns>
            <EmptyDataRowStyle BackColor="Gold" />
            <EmptyDataTemplate>
                <table style="background-color: white" width="100%">
                    <tr>
                    <td style="width:60px">float1</td>
                    <td style="width:75px">date1</td>
                    <td style="width:160px">varchar1</td>
                    <td>varchar2</td>
                    </tr>
                </table>
                <asp:TextBox ID="tb_footer_float1" runat="server" Width="50px"></asp:TextBox>                
                
                <asp:TextBox ID="tb_footer_date1" runat="server" Width="70px"></asp:TextBox>                               
                
                <asp:TextBox ID="tb_footer_varchar1" runat="server"></asp:TextBox>                
                
                <asp:TextBox ID="tb_footer_varchar2" runat="server"></asp:TextBox>                
                
                <asp:Button ID="btnAdd" runat="server" Text="新增" OnClick="btnAdd_Click" CausesValidation="true"                     
                    ToolTip="離線新增一筆資料 (不會真正寫入資料庫)" />
                <asp:Button ID="btnCancer" runat="server" Text="取消" OnClick="btnCancel_Click" ToolTip="清除您在此「新增列」的輸入值" />
            </EmptyDataTemplate>
            <FooterStyle BackColor="Gold" />
        </asp:GridView>
        
        <br />
        <asp:Button ID="btnSave" runat="server" Text="存檔" OnClick="btnSave_Click" CausesValidation="true" 
            OnClientClick="return confirm('您確定要存檔嗎？\n此舉將會把您先前在表格中輸入的「新增、修改、刪除」資料，全部寫入到資料庫。');" 
            ToolTip="把您在表格中輸入的所有「修改、刪除、新增」內容，寫入資料庫" />            
        <br />
        <font color="red" size="2">GridView_Update、GridView_Insert (亦為 DataTable dtUpdate、dtInsert 的內容。用來暫存使用者的離線編輯輸入值，以當作真正要回寫資料庫時的寫入值):</font>
        <br />        
        <asp:GridView ID="GridView_Update" runat="server" Font-Size="Small" Visible="true">
        </asp:GridView>        
        <asp:GridView ID="GridView_Insert" runat="server" Font-Size="Small" Visible="true">
        </asp:GridView>
        <p></p>
        <font color="red" size="2">GridView_InsertInput (亦為 DataTable dtInsertInput 的內容。用來暫存使用者的離線編輯輸入值，以在按下「新增」按鈕之後，將輸入值回填 GridView1):</font>
        <asp:GridView ID="GridView_InsertInput" runat="server" Font-Size="Small" Visible="true">
        </asp:GridView>
        <br /><br />
        <asp:Button ID="Button98" runat="server" Text="無用的空按鈕，測試 Postback" />
                    
    </div>
    </form>
</body>
</html>
